namespace Syntriax.Engine.Core.Abstract;

/// <summary>
/// Represents a game object with various properties and functionalities.
/// </summary>
public interface IGameObject : IEntity, IHierarchyObject, IAssignableTransform, IAssignableBehaviourController, INameable, IInitialize
{
    /// <summary>
    /// Event triggered when the <see cref="Update"/> method is called.
    /// </summary>
    event OnUpdatedEventHandler? OnUpdated;

    /// <summary>
    /// Updates the game object.
    /// </summary>
    void Update();

    delegate void OnUpdatedEventHandler(IGameObject sender);
}
